(document:surround "/std/frame")

;;; Vars

;;; UI
(document:id form (vbox margin 10 align "top" activity #f
    (groupbox title (_ "Limits")
        (gridbox columns "10;90"
            (gridbox columns "50;50"
                (label text (_ "Domain"))
                (edit name "limits_domain")
                (label text (_ "Type"))
                (combobox name "limits_type")
                (label text (_ "Item"))
                (combobox name "limits_item" (when changed (act-update-limits)))
                (label text (_ "Limit"))
                (document:id fspinbox (spinbox name "limits_limit" minimum 0 maximum 16777216 step 512))
                (button text (_ "Add") (when clicked (act-add)))
                (button text (_ "Remove") (when clicked (act-remove))))
            (document:id limits
                         (listbox name "limits"
                                  columns 4
				  row '#((domain . "")
					 (type . "")
					 (item . "")
					 (limit . ""))
                                  header (vector (_ "Domain")
                                                 (_ "Type")
                                                 (_ "Item")
                                                 (_ "Limit"))
                                  (when clicked (limits-change))))
            (button text (_ "Commit") (when clicked (act-commit)))))))

(define (act-update-limits)
  (cond
    ((member (form-value "limits_item") '("core" "data" "fsize" "memlock" "stack" "as"))
     (fspinbox minimum 0 maximum 16777216 step 512))
    ((equal? (form-value "limits_item") "nice")
     (fspinbox minimum -20 maximum 19 step 1))
    (#t
     (fspinbox minimum 0 maximum 2147483647 step 1))))

(define (act-add)
  (limits append-row (vector (form-value "limits_domain")
            (form-value "limits_type")
            (form-value "limits_item")
            (form-value "limits_limit"))))

(define (limits-change)
  (let ((row (list-ref (limits rows) (limits current))))
    (form-update-value "limits_domain" (car (vector-ref row 0)))
    (form-update-value "limits_type"   (car (vector-ref row 1)))
    (form-update-value "limits_item"   (car (vector-ref row 2)))
    (form-update-value "limits_limit"  (car (vector-ref row 3)))))

(define (act-remove)
  (form-update-value "limits_domain" "")
  (form-update-value "limits_type" "")
  (form-update-value "limits_item" "")
  (form-update-value "limits_limit" 0)
  (limits remove (limits current)))

(define (write-rows rows)
  (for-each (lambda (x)
              (woo-write "/limits/save"
                         'domain (car (vector-ref x 0))
                         'type   (car (vector-ref x 1))
                         'item   (car (vector-ref x 2))
                         'limit  (car (vector-ref x 3))))
            rows))

;;; Logic
(define (act-commit)
  (woo-write "/limits/clean")
  (write-rows (limits rows)))

(define (act-reset)
  (catch/message
    (lambda()
      (form-update-enum "limits_type" (woo-list "/limits/types"))
      (form-update-enum "limits_item" (woo-list "/limits/items"))
      (form-update-enum "limits" (woo-list "/limits/limit"))
      (form activity #t))))

(document:root
  (when loaded
    (act-reset)))
